
import java.util.Scanner;

/**
 *
 * @author Dominik
 */
public class EditDistanz {

    int[][] D;
    char[][] E;

    public static void main(String[] args) {
        String s1;
        String s2;
        Scanner scan = new Scanner(System.in);
        System.out.println("Erste Sequenz eingeben:");
        s1 = scan.nextLine();
        System.out.println("Zweite Sequenz eingeben:");
        s2 = scan.nextLine();
        EditDistanz edit = new EditDistanz();
        int dist = edit.rekEditDistanz(s1, s1.length(), s2, s2.length());
        System.out.println("\nrekursiv berechnete Edit-Distanz: " + dist);
        edit.dynEditDistanz(s1, s2);
        dist = edit.D[s1.length()][s2.length()];
        System.out.println("dynamisch berechnete Edit-Distanz: " + dist);
        String editSeq = edit.backtrace(s1.length(), s2.length(), s2);
        System.out.println("Eine optimale Edit-Sequenz: " + editSeq);
    }

    private void dynEditDistanz(String s1, String s2) {
        D = new int[s1.length() + 1][s2.length() + 1];
        E = new char[s1.length() + 1][s2.length() + 1];
        for (int i = 0; i <= s1.length(); i++) {
            for (int j = 0; j <= s2.length(); j++) {
                //oberste Zeile der Matrix ausfüllen 
                if (i == 0) {
                    D[i][j] = j;
                    E[i][j] = 'I';
                } else {
                    // linke Spalte der Matrix ausfüllen
                    if (j == 0) {
                        D[i][j] = i;
                        E[i][j] = 'D';
                    } else {
                        int a = D[i - 1][j] + 1;
                        int b = D[i][j - 1] + 1;
                        int c = 0;
                        boolean copy = false;
                        if (s1.charAt(i - 1) == s2.charAt(j - 1)) {
                            c = D[i - 1][j - 1];
                            copy = true;
                        } else {
                            c = D[i - 1][j - 1] + 1;
                        }
                        if (a <= b) {
                            if (a <= c) {
                                D[i][j] = a;
                                E[i][j] = 'D';
                            } else {
                                D[i][j] = c;
                                if (copy) {
                                    E[i][j] = 'C';
                                } else {
                                    E[i][j] = 'S';
                                }
                            }
                        } else {
                            if (b <= c) {
                                D[i][j] = b;
                                E[i][j] = 'I';
                            } else {
                                D[i][j] = c;
                                if (copy) {
                                    E[i][j] = 'C';
                                } else {
                                    E[i][j] = 'S';
                                }
                            }
                        }
                    }
                }
            }
        }
    }

    private int rekEditDistanz(String s1, int x, String s2, int y) {
        int dist = 0;
        if (x == 0) {
            dist = y;
        } else {
            if (y == 0) {
                dist = x;
            } else {
                int pos1 = rekEditDistanz(s1, x - 1, s2, y) + 1;
                int pos2 = rekEditDistanz(s1, x, s2, y - 1) + 1;
                int pos3;
                if (s1.charAt(x - 1) == s2.charAt(y - 1)) {
                    pos3 = rekEditDistanz(s1, x - 1, s2, y - 1);
                } else {
                    pos3 = rekEditDistanz(s1, x - 1, s2, y - 1) + 1;
                }
                dist = Math.min(pos1, Math.min(pos2, pos3));
            }
        }
        return dist;
    }

    private String backtrace(int i, int j, String str) {
        String seq = "";
        while (i != 0 && j != 0) {
            switch (E[i][j]) {
                case 'D':
                    seq = "D " + seq;
                    i--;
                    break;
                case 'C':
                    seq = "C " + seq;
                    i--;
                    j--;
                    break;
                case 'I':
                    seq = "I(" + str.charAt(j - 1) + ") " + seq;
                    j--;
                    break;
                case 'S':
                    seq = "S(" + str.charAt(j - 1) + ") " + seq;
                    i--;
                    j--;
                    break;
                default:
            }
        }
        return seq;
    }
}
